<?php 
/***************************************************************
 WCMS - Web Content Management System (c) 2006 - Thomas Egtvedt
 
 File: access/module_access/mysql_backup.php
****************************************************************/

/* Includes access, config and language settings */
require ("../head_admin_access.php");
$ADMMOD = "backup";

if ($action == "create_db_backup")
{
include "../../classes/mysql_backup.class.php";

# The name of the file which you want to save backup file in it.
# If this file does not exist it will be created (written over).
# You need to use physical path to this file. e.g. ../db_bkup/(date)_backup.txt
$output = "db_bkup/".time()."_mysql_backup.sql";

# If this is true, only table structure will be stored.
# If this is false, table structure and all data (everything) will be stored.
$structure_only = false;

$backup = new mysql_backup($DBHost,$DBName,$DBUser,$DBPswd,$output,$structure_only);	
	if(!$backup->backup())
	{
	$message = "Failed to create your backup file, please verify directory permissions (db_bkup)";
	} else {
	$message = "Your backup file <em>".time()."_mysql_backup.sql</em> was successfully created!";
	}
}

if ($action == "restore_db_backup")
{
include "../../classes/mysql_backup.class.php";

# The name of the file which you want to save backup file in it.
# If this file does not exist it will be created (written over).
# You need to use physical path to this file. e.g. ../db_bkup/(date)_backup.txt
$output = "db_bkup/".$_POST["selected_db"];

# If this is true, only table structure will be stored.
# If this is false, table structure and all data (everything) will be stored.
$structure_only = false;

$backup = new mysql_backup($DBHost,$DBName,$DBUser,$DBPswd,$output,$structure_only);	
$backup->restore();
}

if ($action == "download_db_backup")
{
	if($_POST['database'] == "" || $_POST['database'] == "Please select a file")
	{
	$bmessage = "Failed to create your zipped download, please make sure you selected a database from the drop down menu.";
	} else {
	include "../../classes/create_zip.class.php";
	
	$zipSQL = new zipfile();
	#$zipSQL->add_dir("db_bkup/");
	$zipSQL->add_file("db_bkup/".$_POST['database'], $_POST['database']);
	$zipSQL->add_file("README.TXT","README.TXT");
	
	// Return Zip File to Browser
	Header("Content-type: application/octet-stream");
	Header ("Content-disposition: attachment; filename=wcms_mysql_backup.zip");
	echo $zipSQL->file();
	
	// OR instead of doing that, you can write out the file to the local disk like this:
	#$filename = "wcms_mysql_backup.zip";
	#$fd = fopen ($filename, "wb");
	#$out = fwrite ($fd, $zipSQL -> file());
	#fclose ($fd);
	
	// then offer it to the user to download:
	#<a href="wcms_mysql_backup.zip">Click here to download the new zip file.</a>
	}
}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $Language["wcms_charset"]; ?>" />
<meta name="author" content="<?php echo WCMS_AUTHOR; ?>" />
<meta name="copyright" content="<?php echo WCMS_COPYRIGHT." - ".WCMS_AUTHOR; ?>" />
<meta name="date" content="<?php echo date("d M Y") ?>" />
<meta name="language" content="<?php echo $Language["wcms_language"]; ?>" />
<meta name="publisher" content="<?php echo WCMS_PUBLISHER; ?>" />
<meta name="version" content="<?php echo WCMS_VERSION; ?>" />
<link rel="shortcut icon" href="<?php echo $wcms_root_url; ?>access/wcms_access_graphic/wcms_favicon.gif" type="image/gif" />
<link href="<?php echo $wcms_root_url; ?>access/wcms_access_style/wcms_access_general.css" rel="stylesheet" type="text/css" />
<title><?php echo $Language["wcms_sitename"]." - Controlpanel - ".WCMS_VERSION; ?></title>
</head>
<body>

<?php 
@include("../header_admin.php");
?>			

<div>
<h2>MySQL Backup</h2>
<p class="note">Simply click the button to create your MySQL database backup. 
It will automatically be stored as a *.sql file on your server.</p>
<br />
<?php
if (!empty($message))
{
?>
<p class="message"><?php echo $message; ?></p>
<br />
<?php
}

$strPath = pathinfo($_SERVER['DOCUMENT_ROOT'].$_SERVER['PHP_SELF']);
$strSQLDir = $strPath['dirname']."/db_bkup";
function listMysqlBackups($path)
{
   # Use this if enabled and PHP version >= 5
   #$list = scandir($path);
   
   $dh  = opendir($path);
   while (false !== ($filename = readdir($dh))) {
   $list[] = $filename;
   }
   sort($list);
   $create = "<select id=\"database\" name=\"database\">\n";
   $create .= "<option>Please select a file</option>\n";
   foreach ($list as $number => $filename)
   {
       # is_file gives you a list of files instead of directories
	   if ( $filename !== '.' && $filename !== '..' && is_file("$path/$filename") )
       {
           // Asign more readable and logic variables
           $dir = $filename;
		       if ($dir == "index.php")
			   {
			   $create .= "";
			   } else { 
               $create .= "<option value=\"".$dir."\">".$dir."</option>\n";
			   }
       }
   }
   $create .= "</select>\n";
   return $create;	
}
?>
<form action="<?php echo $wcms_access_url; ?>module_access/mysql_backup.php?action=create_db_backup" method="post" enctype="multipart/form-data"> 
<input type="submit" name="submit" value="Create a new MySQL database backup" />
</form>
<br />
<h2>Download MySQL Backup</h2>
<p class="note">Select the desired file from the list and click "Download your MySQL database backup". 
Instructions on how to restore your database are found within the automatically created *.zip file.</p>
<br />
<?php
if (!empty($bmessage))
{
?>
<p class="message"><?php echo $bmessage; ?></p>
<br />
<?php
}
?>
<form name="dload_bkup" id="dload_bkup" action="<?php echo $wcms_access_url; ?>module_access/mysql_backup.php?action=download_db_backup" method="post" enctype="multipart/form-data"> 
<?php echo listMysqlBackups($strSQLDir); ?> <input type="submit" name="submit" value="Download your MySQL database backup" />
</form>
</div>

<?php
include("../footer.php");
?>

</body>
</html>
