<?php
/* Specific functions to perform various tasks on your DB
   Their name should give you a hint about what they do... */

require("adm_my_sql.inc.php");

class admfileclass extends dbsql
{
   // the constructor
   function admfileclass($DBName = "")
   {
      $this->dbsql($DBName);
   }

   function getallcatalog($page,$record)
   {
	  global $T_Dlcats;
	  $start = $page*$record;
      $sql = "select * from $T_Dlcats order by parentcatid,categoryname ASC LIMIT $start,$record";
      $result = $this->select($sql);
      return $result;
   }
   
   function getcategorynamebyid($catid)
   {      
      global $T_Dlcats;
	  $sql = "select categoryname from $T_Dlcats where catid='$catid'";
      $result = $this->select($sql);
      $parentname = $result[0]["categoryname"];
      return $parentname;
   }
   
   function getallcategoryname()
   {      
      global $T_Dlcats;
	  $sql = "select catid,categoryname from $T_Dlcats order by categoryname ASC";
      $result = $this->select($sql);      
      return $result;
   }
   
   function getcatalogbyid($catid)
   {      
      global $T_Dlcats;
	  $sql = "select * from $T_Dlcats where catid='$catid'";
      $result = $this->select($sql);      
      return $result;
   }
   
   function addcatalog($categoryname,$categorydesc,$parentcatid)
   {      
      global $T_Dlcats,$admin_catalogalreadyexist;
      $sql = "select * from $T_Dlcats where categoryname='$categoryname' and parentcatid='$parentcatid'";
      $result = $this->select($sql); 
      if (!empty($result)){
      print "$admin_catalogalreadyexist";
      return;
      }     
      $sql = "insert into $T_Dlcats (categoryname,categorydesc,parentcatid) values ('$categoryname','$categorydesc','$parentcatid')";      
      $results = $this->insert($sql);
      return $results;
   }
   
   function editcatalog($categoryname,$categorydesc,$parentcatid,$catid)
   {
      global $T_Dlcats;
	  $sql = "update $T_Dlcats set categoryname='$categoryname',categorydesc='$categorydesc',parentcatid='$parentcatid' where catid='$catid'";      
      $results = $this->update($sql);
      return $results;
   }
   
   function delcatalog($catid,$DownloadPath)
   {
      global $T_Dlcats,$T_Dlfiles;
	  $sql = "delete from $T_Dlcats where catid='$catid'";
      $result = $this->delete($sql);
      $sql = "select fid from $T_Dlfiles where catid='$catid'";
      $result = $this->select($sql);
      if (!empty($result)) {
      	while ( list($key,$val)=each($result) ) {
      		$fid = stripslashes($val["fid"]);
      		$this->delnews($fid,$DownloadPath);
      	}
      }    
   } 
   
   function getallnews($page,$record)
   {
      global $T_Dlfiles;
	  $start = $page*$record;
      $sql = "select * from $T_Dlfiles order by catid,dltitle ASC LIMIT $start,$record";      
      $result = $this->select($sql);
      return $result;
   }
   
   function getcatalognews($page,$record,$catid)
   {
      global $T_Dlfiles;
	  $start = $page*$record;
      $sql = "select * from $T_Dlfiles where catid='$catid' order by fid DESC LIMIT $start,$record";
      $result = $this->select($sql);
      return $result;
   } 
   
   function getstatsnews($page,$record,$order,$sequence)
   {
      global $T_Dlfiles;
	  $start = $page*$record;
      $sql = "select * from $T_Dlfiles order by $order $sequence LIMIT $start,$record";      
      $result = $this->select($sql);
      return $result;
   } 	   
   
   function addnews($catid,$dltitle,$dldesc,$dldemo,$dlsupport,$rating,$ratenum,$filename,$filesize,$dlcount,$activated,$sponsored)
   {        
      global $T_Dlfiles;
	  $adddate = date("Y-m-d");
	  $uptodate = date("Y-m-d");
      $sql = "insert into $T_Dlfiles (catid,dltitle,dldesc,dldemo,dlsupport,rating,ratenum,filename,filesize,dlcount,adddate,uptodate,activated,sponsored) values ('$catid','$dltitle','$dldesc','$dldemo','$dlsupport','$rating','$ratenum','$filename','$filesize','$dlcount','$adddate','$uptodate','$activated','$sponsored')";      
      $results = $this->insert($sql);
      return $results;
   }
   
   function editnews($catid,$dltitle,$dldesc,$dldemo,$dlsupport,$rating,$ratenum,$filename,$filesize,$dlcount,$activated,$sponsored,$fid)
   {
      global $T_Dlfiles;
	  $uptodate = date("Y-m-d");
	  $sql = "update $T_Dlfiles set catid='$catid',dltitle='$dltitle',dldesc='$dldesc',dldemo='$dldemo',dlsupport='$dlsupport',rating='$rating',ratenum='$ratenum',filename='$filename',filesize='$filesize',dlcount='$dlcount',uptodate='$uptodate',activated='$activated',sponsored='$sponsored' where fid='$fid'";      
      $results = $this->update($sql);
      return $results;
   }   

   function delnews($fid,$DownloadPath)
   {
      global $T_Dlfiles;
	  $sql = "select filename from $T_Dlfiles where fid='$fid'";
      $result = $this->select($sql);
      if (!empty($result)) {
      	while ( list($key,$val)=each($result) ) {
      	$filename = stripslashes($val["filename"]);
          if (!empty($filename)) {
          $file = $DownloadPath.$filename;
          unlink($file);
          }
      	}
      }          
      $sql = "DELETE FROM $T_Dlfiles where fid='$fid'";
      $result = $this->delete($sql);      
      return $result;      
   }
   
   function getnewsbyid($fid)
   {      
      global $T_Dlfiles;
	  $sql = "select * from $T_Dlfiles where fid='$fid'";
      $result = $this->select($sql);      
      return $result;
   }
   
}

   function myhtmlentities($str) 
   {  
   global $admin_charset;       
   $str = htmlentities($str, ENT_NOQUOTES, $admin_charset);
   $str = str_replace('&gt;', '>', $str);
   $str = str_replace('&lt;', '<', $str);
   $str = str_replace('\'', '&acute;', $str);
   $str = str_replace('&amp;', '&', $str);
   $str = str_replace('', '&quot;', $str);
   $str = str_replace('', '&quot;', $str);
   $str = str_replace('', '&raquo;', $str);
   $str = str_replace('', '&laquo;', $str);
   $str = str_replace('', '&euro;', $str);
   $str = str_replace('', '&copy;', $str);
   return $str;
   }

?>