<?php
/***************************************************************
 WCMS - Web Content Management System (c) 2006 - Thomas Egtvedt
 
 Functions used to store photos and create thumbs
****************************************************************/

function gd_version() {
   static $gd_version_number = null;
   if ($gd_version_number === null) {
       // Use output buffering to get results from phpinfo()
       // without disturbing the page we're in.  Output
       // buffering is "stackable" so we don't even have to
       // worry about previous or encompassing buffering.
       ob_start();
       phpinfo(8);
       $module_info = ob_get_contents();
       ob_end_clean();
       if (preg_match("/\bgd\s+version\b[^\d\n\r]+?([\d\.]+)/i",
               $module_info,$matches)) {
           $gd_version_number = $matches[1];
       } else {
           $gd_version_number = 0;
       }
   }
   return $gd_version_number;
} 

function makethumbnail($srcFile,$photo_small,$dst_W,$dst_H) {
$data = getimagesize($srcFile);
// Maintain aspect ratio of image.
header("Content-type: {$size['mime']}");
list($width_orig, $height_orig) = $data;
if ($dst_W && ($width_orig < $height_orig)) {
   $dst_W = ($dst_H / $height_orig) * $width_orig;
} else {
   $dst_H = ($dst_W / $width_orig) * $height_orig;
}
// Start creation of thumb, and save it.
switch ($data[2]) {
case 1: 
//print "$data[2]";
$im = @imagecreatefromgif($srcFile);
break;
case 2: 
$im = @imagecreatefromjpeg($srcFile);
break;
case 3: 
$im = @imagecreatefrompng($srcFile);
break;
}
$srcW=imagesx($im);
$srcH=imagesy($im);
// $ni=imagecreate($dst_W,$dst_H);
// imagecreatetruecolor creates much nicer color
// Requires GD version > 2.0.1
if (gd_version() >= 2) {
   $ni = imagecreatetruecolor($dst_W,$dst_H);
   imagecopyresampled($ni,$im,0,0,0,0,$dst_W,$dst_H,$srcW,$srcH);
} else {
   $ni = imagecreate($dst_W,$dst_H);
   imagecopyresized($ni,$im,0,0,0,0,$dst_W,$dst_H,$srcW,$srcH);
}
// imagecopyresized($ni,$im,0,0,0,0,$dst_W,$dst_H,$srcW,$srcH);
// imagecopyresampled creates sharper images
// Requires PHP version > 4.0.6

imagejpeg($ni,$photo_small);
// Flush memory, server malfunction if let out!
imagedestroy($im);
}
?>