<?php
/***************************************************************
 WCMS - Web Content Management System (c) 2006 - Thomas Egtvedt
 
 The access artsec class containing all administrative functions
 to handle the articles and sections
****************************************************************/

require("accessgeneral.class.php");

class accessartsec extends accessgeneral
{
   // the constructor
   function accessartsec($DBName = "")
   {
      $this->accessgeneral($DBName);
   }

### SECTION FUNCTIONS ######################################################################################################

   function createSection($section_name,$section_desc,$section_url,$parent_section_id,$level)
   {      
      global $wcms_db_prefix;
      $query = "SELECT * FROM ".$wcms_db_prefix."_sections WHERE section_name='$section_name' AND parent_section_id='$parent_section_id'";
      $result = $this->select($query); 
      if (!empty($result)){
      echo "ERROR: A section by the same name already exists...";
      exit;
      }     
      $query = "INSERT INTO ".$wcms_db_prefix."_sections (section_name,section_desc,section_url,parent_section_id,level) VALUES ('$section_name','$section_desc','$section_url','$parent_section_id','$level')";      
      $results = $this->insert($query);
      return $results;
   }

   function deleteSection($section_id,$module)
   {
      global $wcms_db_prefix;
	  $query = "SELECT photo_id FROM ".$wcms_db_prefix."_shared_photos WHERE module_name='$module' AND module_id='$section_id'";
      $result = $this->select($query);
      if (!empty($result)) {
      	while ( list($key,$val)=each($result) ) 
		{
      		$photo_id = stripslashes($val["photo_id"]);
			$photo_position = stripslashes($val["photo_position"]);
      		$this->deletePhoto($photo_id,"section",$section_id,$photo_position);
      	}
      }  
	  $query = "DELETE FROM ".$wcms_db_prefix."_sections WHERE section_id='$section_id'";
      $result = $this->delete($query);
      $query = "SELECT article_id FROM ".$wcms_db_prefix."_articles WHERE section_id='$section_id'";
      $result = $this->select($query);
      if (!empty($result)) {
      	while ( list($key,$val)=each($result) ) 
		{
      		$article_id = stripslashes($val["article_id"]);
      		$this->deleteArticle($article_id,"article");
      	}
      }
   }

   function getAllSections($page,$record)
   {
	  global $wcms_db_prefix;
	  $start = $page*$record;
      $query = "SELECT * FROM ".$wcms_db_prefix."_sections ORDER BY parent_section_id,section_name ASC LIMIT $start,$record";
      $result = $this->select($query);
      return $result;
   }
   
   function getSection($section_id)
   {      
      global $wcms_db_prefix;
	  $query = "SELECT * FROM ".$wcms_db_prefix."_sections WHERE section_id='$section_id'";
      $result = $this->select($query);      
      return $result;
   }

   function getSectionArticles($page,$record,$section_id)
   {
      global $wcms_db_prefix;
	  $start = $page*$record;
      $query = "SELECT * FROM ".$wcms_db_prefix."_articles WHERE section_id='$section_id' ORDER BY article_id DESC LIMIT $start,$record";
      $result = $this->select($query);
      return $result;
   } 
      
   function getSectionName($section_id)
   {      
      global $wcms_db_prefix;
	  $query = "SELECT section_name FROM ".$wcms_db_prefix."_sections WHERE section_id='$section_id'";
      $result = $this->select($query);
      $parent_name = $result[0]["section_name"];
      return $parent_name;
   }
   
   function updateSection($section_id,$section_name,$section_desc,$section_url,$parent_section_id,$level)
   {
      global $wcms_db_prefix;
	  $query = "UPDATE ".$wcms_db_prefix."_sections SET section_name='$section_name',section_desc='$section_desc',section_url='$section_url',parent_section_id='$parent_section_id',level='$level' WHERE section_id='$section_id'";      
      $results = $this->update($query);
      return $results;
   }

### ARTICLE FUNCTIONS ######################################################################################################
   
   function addArticle($section_id,$article_title,$article_url,$intro,$content,$published,$nick1,$updated,$nick2,$rating,$ratenum,$counter,$meta_description,$meta_keyword,$displayed,$featured,$comments,$level)
   {        
      global $wcms_db_prefix;
      $query = "INSERT INTO ".$wcms_db_prefix."_articles (section_id,article_title,article_url,intro,content,published,nick1,updated,nick2,rating,ratenum,counter,meta_description,meta_keyword,displayed,featured,comments,level) VALUES ('$section_id','$article_title','$article_url','$intro','$content','$published','$nick1','$updated','$nick2','$rating','$ratenum','$counter','$meta_description','$meta_keyword','$displayed','$featured','$comments','$level')";      
      $results = $this->insert($query);
      return $results;
   }

   function deleteArticle($article_id,$module)
   {
      global $wcms_db_prefix;
	  $query = "SELECT photo_id FROM ".$wcms_db_prefix."_shared_photos WHERE module_name='$module' AND module_id='$article_id'";
      $result = $this->select($query);
      if (!empty($result)) {
      	while ( list($key,$val)=each($result) ) 
		{
      		$photo_id = stripslashes($val["photo_id"]);
			$photo_position = stripslashes($val["photo_position"]);
      		$this->deletePhoto($photo_id,"article",$article_id,$photo_position);
      	}
      }   
	  $this->deleteComments($article_id);     
      $query = "DELETE FROM ".$wcms_db_prefix."_articles WHERE article_id='$article_id'";
      $result = $this->delete($query);      
      return $result;      
   }
    
   function editArticle($article_id,$section_id,$article_title,$article_url,$intro,$content,$published,$nick1,$updated,$nick2,$rating,$ratenum,$counter,$meta_description,$meta_keyword,$displayed,$featured,$comments,$level)
   {
      global $wcms_db_prefix;
	  $query = "UPDATE ".$wcms_db_prefix."_articles SET section_id='$section_id',article_title='$article_title',article_url='$article_url',intro='$intro',content='$content',published='$published',nick1='$nick1',updated='$updated',nick2='$nick2',rating='$rating',ratenum='$ratenum',counter='$counter',meta_description='$meta_description',meta_keyword='$meta_keyword',displayed='$displayed',featured='$featured',comments='$comments',level='$level' WHERE article_id='$article_id'";      
      $results = $this->update($query);
      return $results;
   }
   
   function getAllArticles($page,$record,$cookieSection)
   {
      global $wcms_db_prefix;
	  $start = $page*$record;
      if ($cookieSection != 0)
	  {
	  $query = "SELECT * FROM ".$wcms_db_prefix."_articles WHERE section_id='$cookieSection' ORDER BY section_id,article_title ASC LIMIT $start,$record"; 
	  } else {
	  $query = "SELECT * FROM ".$wcms_db_prefix."_articles ORDER BY section_id,article_title ASC LIMIT $start,$record"; 
	  }     
      $result = $this->select($query);
      return $result;
   }
     
   function getArticle($article_id)
   {      
      global $wcms_db_prefix;
	  $query = "SELECT * FROM ".$wcms_db_prefix."_articles WHERE article_id='$article_id'";
      $result = $this->select($query);      
      return $result;
   }

# Function to display rssfeeds from articles in all sections
    function createRssFeed() 
    { 
		global $wcms_root_url,$wcms_photopath,$wcms_imagepath,$wcms_urlrewrite,$Language,$wcms_db_prefix,$wcms_adminmail;
		# Select the latest updated articles from the database
		$query = "SELECT * FROM ".$wcms_db_prefix."_articles WHERE displayed=1 AND level=9 ORDER BY updated DESC LIMIT 10";		
		$result = mysql_query($query) or die("Query failed: " . mysql_error());
		$x = 0;
		# Prepares the field values for the articles
		$arrayArticles = array();
			while ($row = mysql_fetch_array($result)) 
			{
			$arrayArticles[$x] = $row;
			$x++;
			}
			# If found - Lists all the details for the articles
			if (count($arrayArticles) > 0) 
			{
			$y=0;
			$strRssFeed = "<?xml version=\"1.0\" encoding=\"utf-8\"?".">\n";
			$strRssFeed .= "<rss version=\"2.0\">\n\n";

			$strRssFeed .= "<channel>\n";
			$strRssFeed .= "<title>".$Language['wcms_sitename']."</title>\n";
			$strRssFeed .= "<link>".$wcms_root_url."</link>\n";
			$strRssFeed .= "<description>".$Language['wcms_sitedesc']."</description>\n";
			$strRssFeed .= "<lastBuildDate>".date('D, d M Y H:i:s O')."</lastBuildDate>\n";
			$strRssFeed .= "<language>".$wcms_db_prefix."</language>\n";
			$strRssFeed .= "<ttl>60</ttl>\n";		
			$strRssFeed .= "<generator>".WCMS_VERSION."</generator>\n";
			$strRssFeed .= "<copyright>Copyright ".date(Y)." - ".WCMS_PUBLISHER."</copyright>\n";
			$strRssFeed .= "<webMaster>".$wcms_adminmail."</webMaster>\n";
			$strRssFeed .= "<managingEditor>".$wcms_adminmail."</managingEditor>\n";
			$strRssFeed .= "<docs>http://www.rssboard.org/rss-specification</docs>\n\n";
			
				while($y < count($arrayArticles)) 
				{ 
				$article_id    	= $arrayArticles[$y]['article_id'];
				$module			= "article";
				$section_id    	= $arrayArticles[$y]['section_id'];
				$article_title 	= $arrayArticles[$y]['article_title'];
				$article_title  = $this->rssclean($article_title);
				$article_url   	= $arrayArticles[$y]['article_url'];
				$article_com 	= $arrayArticles[$y]['comments'];
				$article_auth	= $arrayArticles[$y]['nick1'];

				$intro   		= $arrayArticles[$y]['intro'];
				$intro       	= $this->phpinclude($arrayArticles[$y]['intro']);
				eval("\$intro = \"$intro\";");
				$intro       	= $this->rssclean($intro);
				$updated 		= $arrayArticles[$y]['updated'];
				$updated 		= date('D, d M Y H:i:s O', $updated);
				
				$query = "SELECT section_name,section_url FROM ".$wcms_db_prefix."_sections WHERE section_id='$section_id'";		
				$result = mysql_query($query) or die("Query failed: " . mysql_error());
				$xcat = mysql_fetch_array($result);
				$category = $xcat['section_name'];
				$category = $this->rssclean($category);
				$catname = $xcat['section_url'];
				
				$strRssFeed .= "<item>\n";
				$strRssFeed .= "<title>".$article_title."</title>\n";
				if ($wcms_urlrewrite) 
				{
					$link = $wcms_root_url.$article_url."/a".$article_id.".html";
					$catlink = $wcms_root_url.$catname."/s".$section_id.".html";
				} else {
					$link = $wcms_root_url."?choice=article&amp;article_id=".$article_id."&amp;pagetitle=".$article_url;
					$catlink = $wcms_root_url."?choice=section&amp;section_id=".$section_id;
				}
				$strRssFeed .= "<link>".$link."</link>\n";
				$strRssFeed .= "<guid isPermaLink=\"true\">".$link."</guid>\n";
				if ($article_com)
				{
					$strRssFeed .= "<comments>".$link."#com1</comments>\n";
				}
				$strRssFeed .= "<pubDate>".$updated."</pubDate>\n";
				$strRssFeed .= "<author>".$article_auth."</author>\n";
				$strRssFeed .= "<category domain=\"".$catlink."\">".$category."</category>\n";
				$strRssFeed .= "<description>".$intro."</description>\n";
				$strRssFeed .= "</item>\n\n";
				$y++;
				}
			$strRssFeed .= "</channel>\n";
			$strRssFeed .= "</rss>\n";
			}
		return $strRssFeed;
	}

### COMMENT FUNCTIONS ######################################################################################################
   
   function deleteComment($comment_id)
   {      
      global $wcms_db_prefix;
	  $query = "DELETE FROM ".$wcms_db_prefix."_comments WHERE comment_id='$comment_id'";
      $result = $this->delete($query);      
      return $result;
   }
   
   function deleteComments($article_id)
   {      
      global $wcms_db_prefix;
	  $query = "DELETE FROM ".$wcms_db_prefix."_comments WHERE module_name='$module_name' AND module_id='$module_id'";
      $result = $this->delete($query);      
      return $result;
   }
   
   function editComment($comment_id,$comment,$website)
   {
      global $wcms_db_prefix;
	  $query = "UPDATE ".$wcms_db_prefix."_comments SET comment='$comment',website='$website' WHERE comment_id='$comment_id'";      
      $result = $this->update($query);
      return $result;
   }
      
   function getComment($comment_id)
   {      
      global $wcms_db_prefix;
	  $query = "SELECT * FROM ".$wcms_db_prefix."_comments WHERE comment_id='$comment_id'";
      $result = $this->select($query);      
      return $result;
   }

   function getComments($module_name,$module_id)
   {      
      global $wcms_db_prefix;
	  $query = "SELECT * FROM ".$wcms_db_prefix."_comments WHERE module_name='$module_name' AND module_id='$module_id' ORDER BY added DESC";
      $result = $this->select($query);      
      return $result;
   }
   
   function newComment($module_name,$module_id,$author,$email,$website,$comment,$added)
   {
      global $wcms_db_prefix;
      $query = "INSERT INTO ".$wcms_db_prefix."_comments (module_name,module_id,author,email,website,comment,added) VALUES ('$module_name','$module_id','$author','$email','$website','$comment','$added')";
      $result = $this->insert($query);
      return $result;
   }

### PHOTO FUNCTIONS ########################################################################################################
   
   function addPhoto($module_name,$module_id,$photo_title,$userfile_name,$photo_thumb,$photo_position,$width_orig,$height_orig,$width_thumb,$height_thumb)
   {
      global $wcms_db_prefix;
      $query = "INSERT INTO ".$wcms_db_prefix."_shared_photos (module_name,module_id,photo_title,photo_orig,photo_thumb,photo_position,width_orig,height_orig,width_thumb,height_thumb) VALUES ('$module_name','$module_id','$photo_title','$userfile_name','$photo_thumb','$photo_position','$width_orig','$height_orig','$width_thumb','$height_thumb')";
      $result = $this->insert($query);
      return $result;
   }
     
   function editPhoto($photo_id,$newphoto_position,$rphoto_id,$photo_position,$module_name,$module_id)
   {
      global $wcms_db_prefix;
	  $query = "UPDATE ".$wcms_db_prefix."_shared_photos SET photo_position='$newphoto_position' WHERE photo_id='$photo_id' AND module_name='$module_name' AND module_id='$module_id'";      
      $result = $this->update($query);
	  $query2 = "UPDATE ".$wcms_db_prefix."_shared_photos SET photo_position='$photo_position' WHERE photo_id='$rphoto_id' AND module_name='$module_name' AND module_id='$module_id'";      
      $result = $this->update($query2);
      return $result;
   }	 
	     
   function deletePhoto($photo_id,$module_name,$module_id,$photo_position)
   {
      global $wcms_db_prefix,$wcms_rel_photopath;
	  $query = "SELECT photo_orig,photo_thumb FROM ".$wcms_db_prefix."_shared_photos WHERE photo_id='$photo_id'";
      $result = $this->select($query);
      $photo_orig = $result[0]["photo_orig"];
      $photo_thumb = $result[0]["photo_thumb"]; 
		  if (!empty($photo_orig)) 
		  {
		  $file = $wcms_rel_photopath.$photo_orig;
		  unlink($file);
		  $file = $wcms_rel_photopath."thumbs/".$photo_thumb;
		  unlink($file);
		  }    
      $query2 = "DELETE FROM ".$wcms_db_prefix."_shared_photos WHERE photo_id='$photo_id'";
      $result = $this->delete($query2);   
	  $query3 = "SELECT photo_position FROM ".$wcms_db_prefix."_shared_photos WHERE module_name='$module_name' AND module_id='$module_id'";
      $result = $this->select($query3);
	  $query4 = "UPDATE ".$wcms_db_prefix."_shared_photos SET photo_position=photo_position-1 WHERE photo_position > '$photo_position' AND module_name='$module_name' AND module_id='$module_id'";
	  $result = $this->update($query4);  
      return $result;
   }
   
   function getPhotos($module_name,$module_id)
   {      
      global $wcms_db_prefix;
	  $query = "SELECT * FROM ".$wcms_db_prefix."_shared_photos WHERE module_name='$module_name' AND module_id='$module_id' ORDER BY photo_position";
      $result = $this->select($query);      
      return $result;
   }

   function getPhotoByPosition($photo_position,$module_name,$module_id)
   {      
      global $wcms_db_prefix;
	  $query = "SELECT photo_id FROM ".$wcms_db_prefix."_shared_photos WHERE photo_position='$photo_position' AND  module_name='$module_name' AND module_id='$module_id'";
	  $result = $this->select($query);      
      return $result;
   }

### SITEPOST FUNCTIONS #####################################################################################################

   function deleteSitepost($message_id)
   {      
      global $wcms_db_prefix;
	  $query = "DELETE FROM ".$wcms_db_prefix."_contact WHERE message_id='$message_id'";
      $result = $this->delete($query);      
      return $result;
   }

   function getSitepost($page,$record)
   {
	  global $wcms_db_prefix;
	  $start = $page*$record;
      $query = "SELECT * FROM ".$wcms_db_prefix."_contact ORDER BY message_id DESC LIMIT $start,$record";
      $result = $this->select($query);
      return $result;
   }

### STATS FUNCTIONS ########################################################################################################
   
   function getArticleStats($page,$record,$order,$sequence)
   {
      global $wcms_db_prefix;
	  $module_name = "article";
	  $start = $page*$record;
      $query = "SELECT * FROM ".$wcms_db_prefix."_counter_wcms WHERE module_name='$module_name' ORDER BY $order $sequence LIMIT $start,$record";
      $result = $this->select($query);
      return $result;
   }
   
   function getSectionStats($page,$record,$order,$sequence)
   {
      global $wcms_db_prefix;
	  $module_name = "section";
	  $start = $page*$record;
      $query = "SELECT * FROM ".$wcms_db_prefix."_counter_wcms WHERE module_name='$module_name' ORDER BY $order $sequence LIMIT $start,$record";
      $result = $this->select($query);
      return $result;
   }
      
   function getStats($page,$record,$order,$sequence)
   {
      global $wcms_db_prefix;
	  $start = $page*$record;
      $query = "SELECT * FROM ".$wcms_db_prefix."_counter_wcms ORDER BY $order $sequence LIMIT $start,$record";      
      $result = $this->select($query);
      return $result;
   }
   
   function getTaFStats($page,$record,$order,$sequence)
   {
      global $wcms_db_prefix;
	  $start = $page*$record;
      $query = "SELECT * FROM ".$wcms_db_prefix."_counter_tellafriend ORDER BY $order $sequence LIMIT $start,$record";      
      $result = $this->select($query);
      return $result;
   } 
   
} # End class

### OLD FUNCTION ###########################################################################################################

   function myhtmlentities($str) 
   {  
	   global $admin_charset;       
	   $str = mb_convert_encoding($str, 'HTML-ENTITIES', $admin_charset);
	   $str = htmlspecialchars($str, ENT_QUOTES, $admin_charset);
	   $str = str_replace('&amp;', '&', $str);
	   $str = str_replace('& ', '&amp; ', $str);
	   $str = str_replace('&gt;', '>', $str);
	   $str = str_replace('&lt;', '<', $str);
	   $str = str_replace('&quot;', '"', $str);
	   return $str;
   }
?>