// new adIt toolbar used with permission
// by Alex King
// http://www.alexking.org/

var adButtons = new Array();
var adLinks = new Array();
var adOpenTags = new Array();

function adButton(id, display, tagStart, tagEnd, access, open) {
	this.id = id;				// used to name the toolbar button
	this.display = display;		// label on button
	this.tagStart = tagStart; 	// open tag
	this.tagEnd = tagEnd;		// close tag
	this.access = access;		// access key
	this.open = open;			// set to -1 if tag does not need to be closed
}

function zeroise(number, threshold) {
	// FIXME: or we could use an implementation of printf in js here
	var str = number.toString();
	if (number < 0) { str = str.substr(1, str.length) }
	while (str.length < threshold) { str = "0" + str }
	if (number < 0) { str = '-' + str }
	return str;
}

var now = new Date();
var datetime = now.getFullYear() + '-' + 
				zeroise(now.getMonth() + 1, 2) + '-' +
				zeroise(now.getDate(), 2) + 'T' + 
				zeroise(now.getHours(), 2) + ':' + 
				zeroise(now.getMinutes(), 2) + ':' + 
				zeroise(now.getSeconds() ,2) +
				// FIXME: we could try handling timezones like +05:30 and the like
				zeroise((now.getTimezoneOffset()/60), 2) + ':' + '00';

adButtons[adButtons.length] = 
new adButton('ad_strong'
,'bold'
,'<strong>'
,'</strong>'
,'b'
);

adButtons[adButtons.length] = 
new adButton('ad_em'
,'em'
,'<em>'
,'</em>'
,'i'
);

adButtons[adButtons.length] = 
new adButton('ad_acronym'
,'acronym'
,'<acronym>'
,'</acronym>'
,'y'
);

adButtons[adButtons.length] = 
new adButton('ad_link'
,'link'
,''
,'</a>'
,'a'
); // special case

adButtons[adButtons.length] = 
new adButton('ad_block'
,'b-quote'
,'<blockquote>'
,'</blockquote>'
,'q'
);


adButtons[adButtons.length] = 
new adButton('ad_del'
,'del'
,'<del datetime="' + datetime + '">'
,'</del>'
,'d'
);

adButtons[adButtons.length] = 
new adButton('ad_ins'
,'ins'
,'<ins datetime="' + datetime + '">'
,'</ins>'
,'s'
);

adButtons[adButtons.length] = 
new adButton('ad_img'
,'img'
,''
,''
,'m'
,-1
); // special case

adButtons[adButtons.length] = 
new adButton('ad_ul'
,'ul'
,'<ul>\n'
,'</ul>\n\n'
,'u'
);

adButtons[adButtons.length] = 
new adButton('ad_ol'
,'ol'
,'<ol>\n'
,'</ol>\n\n'
,'o'
);

adButtons[adButtons.length] = 
new adButton('ad_li'
,'li'
,'\t<li>'
,'</li>\n'
,'l'
);

adButtons[adButtons.length] = 
new adButton('ad_pre'
,'code'
,'<code>'
,'</code>'
,'c'
);

adButtons[adButtons.length] = 
new adButton('ad_more'
,'more'
,'<!--more-->'
,''
,'t'
,-1
);

adButtons[adButtons.length] = 
new adButton('ad_next'
,'page'
,'<!--nextpage-->'
,''
,'p'
,-1
);

adButtons[adButtons.length] = new adButton('ad_IMG-R'
,'IMG-R'
,'<div style="float: right; margin-left: 10px; margin-bottom: 10px;">'
,'</div>'
,''
);

adButtons[adButtons.length] = new adButton('ad_IMG-L'
,'IMG-L'
,'<div style="float: left; margin-right: 10px; margin-bottom: 10px;">'
,'</div>'
,''
);

adButtons[adButtons.length] = new adButton('ad_IMG-C'
,'IMG-C'
,'<div style="text-align: center;">'
,'</div>'
,''
);

adButtons[adButtons.length] = new adButton('ad_IMG-Link'
,'IMG-Link'
,'<a href="http://"> <img src="http://" alt="" border="0" /></a>'
,''
,''
);

adButtons[adButtons.length] = new adButton('ad_EndAll'
,'EndAll'
,'<br clear="all" />'
,''
,''
);

function adLink() {
	this.display = '';
	this.URL = '';
	this.newWin = 0;
}

adLinks[adLinks.length] = new adLink('WordPress'
                                    ,'http://wordpress.org/'
                                    );

adLinks[adLinks.length] = new adLink('alexking.org'
                                    ,'http://www.alexking.org/'
                                    );

function adShowButton(button, i) {
	if (button.id == 'ad_img') {
		document.write('<input type="button" id="' + button.id + '" accesskey="' + button.access + '" class="ad_button" onclick="adInsertImage(adCanvas);" value="' + button.display + '" /> ');
	}
	else if (button.id == 'ad_photo') {
		document.write('<input type="button" id="' + button.id + '" accesskey="' + button.access + '" class="ad_button" onclick="adInsertPhoto(adCanvas);" value="' + button.display + '" /> ');
	}
	else if (button.id == 'ad_link') {
		document.write('<input type="button" id="' + button.id + '" accesskey="' + button.access + '" class="ad_button" onclick="adInsertLink(adCanvas, ' + i + ');" value="' + button.display + '" /> ');
	}
	else {
		document.write('<input type="button" id="' + button.id + '" accesskey="' + button.access + '" class="ad_button" onclick="adInsertTag(adCanvas, ' + i + ');" value="' + button.display + '"  /> ');
	}
}

function adShowLinks() {
	var tempStr = '<select onchange="adQuickLink(this.options[this.selectedIndex].value, this);"><option value="-1" selected>(Quick Links)</option>';
	for (i = 0; i < adLinks.length; i++) {
		tempStr += '<option value="' + i + '">' + adLinks[i].display + '</option>';
	}
	tempStr += '</select>';
	document.write(tempStr);
}

function adAddTag(button) {
	if (adButtons[button].tagEnd != '') {
		adOpenTags[adOpenTags.length] = button;
		document.getElementById(adButtons[button].id).value = '/' + document.getElementById(adButtons[button].id).value;
	}
}

function adRemoveTag(button) {
	for (i = 0; i < adOpenTags.length; i++) {
		if (adOpenTags[i] == button) {
			adOpenTags.splice(i, 1);
			document.getElementById(adButtons[button].id).value = 		document.getElementById(adButtons[button].id).value.replace('/', '');
		}
	}
}

function adCheckOpenTags(button) {
	var tag = 0;
	for (i = 0; i < adOpenTags.length; i++) {
		if (adOpenTags[i] == button) {
			tag++;
		}
	}
	if (tag > 0) {
		return true; // tag found
	}
	else {
		return false; // tag not found
	}
}	

function adCloseAllTags() {
	var count = adOpenTags.length;
	for (o = 0; o < count; o++) {
		adInsertTag(adCanvas, adOpenTags[adOpenTags.length - 1]);
	}
}

function adQuickLink(i, thisSelect) {
	if (i > -1) {
		var newWin = '';
		if (adLinks[i].newWin == 1) {
			newWin = ' target="_blank"';
		}
		var tempStr = '<a href="' + adLinks[i].URL + '"' + newWin + '>' 
		            + adLinks[i].display
		            + '</a>';
		thisSelect.selectedIndex = 0;
		adInsertContent(adCanvas, tempStr);
	}
	else {
		thisSelect.selectedIndex = 0;
	}
}

function adSpell(myField) {
	var word = '';
	if (document.selection) {
		myField.focus();
	    var sel = document.selection.createRange();
		if (sel.text.length > 0) {
			word = sel.text;
		}
	}
	else if (myField.selectionStart || myField.selectionStart == '0') {
		var startPos = myField.selectionStart;
		var endPos = myField.selectionEnd;
		if (startPos != endPos) {
			word = myField.value.substring(startPos, endPos);
		}
	}
	if (word == '') {
		word = prompt('Enter a word to look up:', '');
	}
	if (word != '') {
		window.open('http://dictionary.reference.com/search?q=' + escape(word));
	}
}

function adToolbar() {
	document.write('<div id="ad_toolbar">');
	for (i = 0; i < adButtons.length; i++) {
		adShowButton(adButtons[i], i);
	}
//	document.write('<input type="button" id="ad_spell" class="ad_button" onclick="adSpell(adCanvas);" title="Dictionary lookup" value="Dict." />');
	document.write('<input type="button" id="ad_close" class="ad_button" onclick="adCloseAllTags();" title="Close all open tags" value="Close Tags" />');
//	adShowLinks(); // disabled by default
	document.write('</div>');
}

// insertion code

function adInsertTag(myField, i) {
	//IE support
	if (document.selection) {
		myField.focus();
	    sel = document.selection.createRange();
		if (sel.text.length > 0) {
			sel.text = adButtons[i].tagStart + sel.text + adButtons[i].tagEnd;
		}
		else {
			if (!adCheckOpenTags(i) || adButtons[i].tagEnd == '') {
				sel.text = adButtons[i].tagStart;
				adAddTag(i);
			}
			else {
				sel.text = adButtons[i].tagEnd;
				adRemoveTag(i);
			}
		}
		myField.focus();
	}
	//MOZILLA/NETSCAPE support
	else if (myField.selectionStart || myField.selectionStart == '0') {
		var startPos = myField.selectionStart;
		var endPos = myField.selectionEnd;
		var cursorPos = endPos;
		var scrollTop = myField.scrollTop;

		if (startPos != endPos) {
			myField.value = myField.value.substring(0, startPos)
			              + adButtons[i].tagStart
			              + myField.value.substring(startPos, endPos) 
			              + adButtons[i].tagEnd
			              + myField.value.substring(endPos, myField.value.length);
			cursorPos += adButtons[i].tagStart.length + adButtons[i].tagEnd.length;
		}
		else {
			if (!adCheckOpenTags(i) || adButtons[i].tagEnd == '') {
				myField.value = myField.value.substring(0, startPos) 
				              + adButtons[i].tagStart
				              + myField.value.substring(endPos, myField.value.length);
				adAddTag(i);
				cursorPos = startPos + adButtons[i].tagStart.length;
			}
			else {
				myField.value = myField.value.substring(0, startPos) 
				              + adButtons[i].tagEnd
				              + myField.value.substring(endPos, myField.value.length);
				adRemoveTag(i);
				cursorPos = startPos + adButtons[i].tagEnd.length;
			}
		}
		myField.focus();
		myField.selectionStart = cursorPos;
		myField.selectionEnd = cursorPos;
		myField.scrollTop = scrollTop;
	}
	else {
		if (!adCheckOpenTags(i) || adButtons[i].tagEnd == '') {
			myField.value += adButtons[i].tagStart;
			adAddTag(i);
		}
		else {
			myField.value += adButtons[i].tagEnd;
			adRemoveTag(i);
		}
		myField.focus();
	}
}

function adInsertContent(myField, myValue) {
	//IE support
	if (document.selection) {
		myField.focus();
		sel = document.selection.createRange();
		sel.text = myValue;
		myField.focus();
	}
	//MOZILLA/NETSCAPE support
	else if (myField.selectionStart || myField.selectionStart == '0') {
		var startPos = myField.selectionStart;
		var endPos = myField.selectionEnd;
		myField.value = myField.value.substring(0, startPos)
		              + myValue 
                      + myField.value.substring(endPos, myField.value.length);
		myField.focus();
		myField.selectionStart = startPos + myValue.length;
		myField.selectionEnd = startPos + myValue.length;
	} else {
		myField.value += myValue;
		myField.focus();
	}
}

function adInsertLink(myField, i, defaultValue) {
	if (!defaultValue) {
		defaultValue = 'http://';
	}
	if (!adCheckOpenTags(i)) {
		var URL = prompt('Enter the URL' ,defaultValue);
		if (URL) {
			adButtons[i].tagStart = '<a href="' + URL + '">';
			adInsertTag(myField, i);
		}
	}
	else {
		adInsertTag(myField, i);
	}
}

function adInsertImage(myField) {
	var myValue = prompt('Enter the URL of the image', 'http://');
	if (myValue) {
		myValue = '<img src="' 
				+ myValue 
				+ '" alt="' + prompt('Enter a description of the image', '') 
				+ '" />';
		adInsertContent(myField, myValue);
	}
}

function adInsertPhoto(myField) {
	var myValue = prompt('Please select how you wish your photo to be dsiplayed:\n\nbright = Big picture to the right\n bleft = Big picture to the left\n right = Small picture to the right\n left = Small picture to the left\n', '');
	if (myValue) {
		myValue = '{$' 
				+ myValue 
				+ '[' + prompt('Enter a photo number, NB! zero equls the first photo...', '') 
				+ ']}';
		adInsertContent(myField, myValue);
	}
}